! Time-stamp: <2010-12-16 21:33:00 guenter>
!
! smsextract.prg

define/local type/i/1/1 0
define/local ans/c/1/1 "y"
define/local catal/i/1/1 0
define/local name/c/1/80 " " all
define/local i/i/1/1 1
define/local center/i/1/1 1
define/local bcuts/r/1/2 1.,1.
define/local nthres/r/1/1 {thres}
define/local ypixels/i/1/1 1
define/local ycenter/r/1/1 0.0
define/local yfwhm/r/1/1 0.0
define/local numlin/i/1/1 6
define/local scale/r/1/1 {smsdisplayscale}
define/local skyav/r/1/1 0.0
define/para p1 {smslastcat} ?  "Catalogue: "
define/para p2 "n" ? 	   "View each frame? (y/n): "
define/para p3 "n" ?       "Median sky filter? (y/n): "

if p1 .eq. "JUMP" goto result

if p1 .eq. "-h" then 
   @@ sms/help/extracthelp.prg
   return
endif

if m$filtyp("{p1}"," ") .ne. 9 then
   write/sms "{p1} {nocat}" red
   return
endif 

write/sms "{usingcat} {p1}"

-copy "{p1}" TOEXTR.cat

result:
inquire/keyw smsresult "{resultask} [{smsresult}] : "
if smsresult .eq. " " goto result 

if "{p1}" .eq. "JUMP" goto extrac

set/midas newfiles=MIDAS,bdf,tbl output={smsverb}

if "{smsflip}" .ne. "n" then
   FLIP:
   store/frame name TOEXTR.cat 1 FFERTIG
     flip/image {name}
     goto FLIP
   FFERTIG:
   flip/image &ts
endif

execute/catalog write/desc TOEXTR.cat start/d/1/2 1.0,1.0
execute/catalog write/desc TOEXTR.cat step/d/1/1 1.0
write/desc &ts start/d/1/2 1.0,1.0 
write/desc &ts step/d/1/1 1.0

statis/ima &ts
compute/ima &nts = (&ts - {outputr(3)})/{outputr(2)}

set/long wlc=middummnts

@@ sms/smsdisplay.prg &nts " "

thres:
clear/chan overlay

set/long thres={nthres}
search/long
compute/table line.tbl :X_COORD = :X
compute/table line.tbl :Y_COORD = :Y 
draw/cross line.tbl intens=6,0

set/form f6.5
inquire/keyw nthres "{thresask} {thres}? :"
set/form
if nthres .ne. thres goto thres
ystart = {&nts,npix(2)}/2

graph/long 
ident:
identify/long
@S lnident,seline >/dev/null
numlin = outputi(1)
if numlin .le. 5 set/long dcx=2
if numlin .le. 3 set/long dcx=1
set/form i1
!write/sms "{dcxask}        : DCX     = {dcx(1)} ?"
inquire/keyw dcx "dcx = {dcx} ?"

set/form
select/table line.tbl all
calibrate/long >/dev/null
plot/cali
show/long R

ans = "y"
inquire/keyw ans "Ok ?"
if ans .ne. "y" goto ident
write/sms "{smsatwork}"
set/midas output={smsverb}

set/form f2.5
inquire/keyword smslindisp "{lindispask} [{smslindisp}] Angstr./px"
set/form

rectify/long &nts &rts
!outdisk/fits middummrts.bdf middummrts.fits

extrac:

catal = 0
create/icat EXTRACTED.cat NULL
if "{smstype}" .eq. "s" then 
    REBS_LOOP:
    store/frame name TOEXTR.cat 1 REBFERTIG
      copy/ii {name} &q
      rectify/long &q &reb
      write/desc &reb start/d/2/1 1.0
      average/colu &avc = &reb
      write/desc &avc start 1.0
      center/gauss &avc
      set/midas output={smsverb}
      ycenter = {outputr(5)}
      yfwhm   = {outputr(12)}
      object(1) = ycenter - 3 * yfwhm
      object(2) = ycenter + 3 * yfwhm
      lowsky(1) = {&avc,start}
      lowsky(2) = object(1) - 5
      uppsky(1) = object(2) + 5
      uppsky(2) = {&avc,npix}
      if {uppsky(1)} .ge. {uppsky(2)} .or. {object(2)} .ge. {uppsky(2)} then
	 write/sms "{smsupper}"
	 return
      elseif {lowsky(2)} .le. {lowsky(1)} .or. {object(1)} .le. {lowsky(1)} then
	 write/sms "{smslower}"
	 return
      endif
      if p2(1:1) .eq. "y" then
	 clear/channel overlay
	 load/image &reb sc={smsdisplayscale}
	 draw/rectangle <,{lowsky(1)},>,{lowsky(2)} F N 5
	 draw/rectangle <,{uppsky(1)},>,{uppsky(2)} F N 5
	 draw/rectangle <,{object(1)},>,{object(2)} F N 2
	 wait/secs 2
      endif
      statis/image &reb [<,@{lowsky(1)}:>,@{lowsky(2)}]
      skyav = {outputr(8)}
      statis/image &reb [<,@{uppsky(1)}:>,@{uppsky(2)}]
      skyav = {outputr(8)}
      if skyav .lt. 0 compute/image &reb = &reb - {skyav}  
      copy/ii &reb &rf
      if p3(1:1) .eq. "y" filter/median &reb &rf 20,0,0
      skyfit/long &rf &sky
      extract/long &reb &exx &sky
      rebin/line &exx EX{name} {smslindisp} 
      add/icat EXTRACTED.cat EX{name} 
      goto REBS_LOOP
    REBFERTIG:
elseif smstype .eq. "m" then 
    REBE_LOOP:
    clear/channel overlay
    store/frame name TOEXTR.cat 1 REBEFERTIG
      rectify/long {name} &reb
      load/image &reb sc={smsdisplayscale}
      write/sms "{skyask}"
      get/curs middummskypos.tbl ? ? 4
      sort/tabl &skypos.tbl :Y_coordpix
      set/long lowsky={&skypos.tbl,:Y_coordpix,@1},{&skypos,:Y_coordpix,@2}
      set/long uppsky={&skypos.tbl,:Y_coordpix,@3},{&skypos,:Y_coordpix,@4}
      clear/channel overlay
      write/sms "{objask}"
      get/curs middummobjpos.tbl ? ? 2
      sort/tabl &objpos.tbl :Y_coordpix
      set/long object={&objpos.tbl,:Y_coordpix,@1},{&objpos.tbl,:Y_coordpix,@2}
      if p2(1:1) .eq. "y" then
	 clear/channel overlay
	 load/image &reb sc={smsdisplayscale}
	 draw/rectangle <,{&skypos.tbl,:Y_coord,@1},>,{&skypos.tbl,:Y_coord,@1} F N 5
	 draw/rectangle <,{&skypos.tbl,:Y_coord,@3},>,{&skypos.tbl,:Y_coord,@4} F N 5
	 draw/rectangle <,{&objpos.tbl,:Y_coord,@1},>,{&objpos.tbl,:Y_coord,@2} F N 2
	 wait/secs 2
      endif
      statis/image &reb [<,@{lowsky(1)}:>,@{lowsky(2)}],[<,@{uppsky(1)}:>,@{uppsky(2)}]
      skyav = {outputr(8)} + {&reb,statistic(8)}
      if skyav .lt. 0 compute/image &reb = &reb - {skyav}
      skyfit/long &reb &sky
      copy/ii &reb &rf
      if p3(1:1) .eq. "y" filter/median &reb &rf 20,0,0
      extract/long &rf &exx &sky
      rebin/line &exx EX{name} {smslindisp}
      plot/row EX{name}
      add/icat EXTRACTED EX{name} 
      goto REBE_LOOP
    REBEFERTIG:
elseif smstype .eq. "f" then
       REBF_LOOP:
       store/frame name TOEXTR.cat 1 REBFFERTIG
       rectify/long {name} &reb 
       average/row &exx = middummreb.bdf
       rebin/line &exx EX{name} {smslindisp}
       add/icat EXTRACTED EX{name}
       goto REBF_LOOP
       REBFFERTIG:
       define/local lzeile/r/1/1 100.0
       lzeile = {middummreb,npix(2)} + {middummreb,start(2)} - 1
       set/long object={middummreb,start(2)},{lzeile}
endif

inquire/keyw smsselect "{selectask} [y/n] [{smsselect}]:"
if smsselect .eq. "y" then
   catal/sms EXTRACTED.cat
endif

average/image {smsresult} = EXTRACTED.cat
write/desc {smsresult} lhcuts/r/1/2 0.,0.
set/graph pm=1 xa ya
plot/row {smsresult} 
copy/ii {smsresult} {smsresult}_av
write/sms "--> {smsresult}  --> {smsresult}_av" green
set/long dcx=3

! output a 1D spectrum of comparision lamp

define/local startwl/i/1/1 {&rts,start(1)}
define/local endwl/i/1/1 0
define/local lamp/c/1/10 " "
define/local point/i/1/1 5
point = m$index(lincat,".")-1
lamp = "{lincat(1:{point})}"
endwl = startwl + {&rts,npix(1)}*{&rts,step(1)}
average/row  &collapsed = &rts {object(1)},{object(2)}
set/form i0
outdisk/fits middummcollapsed.bdf {lamp}{startwl}to{endwl}.fits
set/form
write/sms "--> {lamp}{startwl}to{endwl}.fits" green
