! Time-stamp: <2010-12-16 21:07:26 guenter>
!
! smsrotate.prg

define/para p1 {smslastcat} ? "Catalogue: "

if p1 .eq. "-h" then
   @@ sms/rotatehelp.prg
   return
endif

if m$filtyp("{p1}"," ") .ne. 9 then
   write/sms "{p1} {nocat}"
   return
endif 

define/local deltaX/r/1/1 0.0
define/local deltaY/r/1/1 1.0
define/local catal/i/1/1 0
define/local name/c/1/80 " " ALL
define/local absangle/r/1/1 0.0
define/local extrdata/i/1/4 0,0,0,0
define/local rotangle/r/1/1 0.0

set/midas newfiles=MIDAS,bdf,tbl output={smsverb}

if m$exist("middummts.bdf") .eq. 0 then
   write/sms "*** CSPEC/SMS !"
   return
endif
copy/ii &ts &ots

write/sms "{usingcat} {p1}"

cuts/image #0001_{p1} =high
@@ sms/smsdisplay.prg #0001_{p1} " "


write/sms "Move Cursors" cyan

extract/trace ? ? N 

deltaX = {trace,START_END_TRACEPIX(1)} - {trace,START_END_TRACEPIX(3)}
deltaY = {trace,START_END_TRACEPIX(4)} - {trace,START_END_TRACEPIX(2)} 
 
if {deltaY} .ne. 0 then 
   rotangle = m$atan({deltaY}/{deltaX})
   write/sms "{rotationmsg} {rotangle}°"
   absangle = m$abs({rotangle})
   rebin/rotate &ots &rts {rotangle}
   extrdata(1) = {&ots,npix(2)}*m$sin({absangle})
   extrdata(2) = {&ots,npix(1)}*m$sin({absangle})
   extrdata(3) = {&ots,npix(1)}*m$cos({absangle})
   extrdata(4) = {&ots,npix(2)}*m$cos({absangle})
   create/icat ROTOBJ.cat NULL
   write/sms {smsatwork}
   ROTATE:
   store/frame name {p1} 1 FINIS
     rebin/rotate {name} &rotated {rotangle}
     extract/image R{name} = &rotated [@{extrdata(1)},@{extrdata(2)}:@{extrdata(3)},@{extrdata(4)}]
     add/icat ROTOBJ.cat R{name}
     goto ROTATE
   FINIS:
   extract/image &ts = &rts [@{extrdata(1)},@{extrdata(2)}:@{extrdata(3)},@{extrdata(4)}]
   average/image MROTOBJ = ROTOBJ.cat ? ? Median

   cuts/image MROTOBJ =high
   @@ sms/smsdisplay.prg MROTOBJ "MROTOBJ.bdf"
   set/sms smslastcat=ROTOBJ.cat
else
   write/sms "{norot}"
endif

write/sms "{actucat} {smslastcat}"
