! Time-stamp: <2010-09-18 16:17:28 guenter>
!
! smsscaledark.prg
!
! .USAGE dscale/sms DARK BIAS EXPOSURETIME
!
define/local exptime/r/1/1 {#1_OBJECTS.cat,o_time(7)}
define/local darktime/r/1/1 1.0
define/local factor/r/1/1 1.0

define/para p1 "MODARK.bdf" ? "MASTERDARK "

if p1 .eq. "-h" then
   @@ sms/help/scaledarkhelp.prg
   return
endif

define/para p2 MBIAS.bdf ? "MASTERBIAS" 
define/para p3 {#1_OBJECTS.cat,o_time(7)} N

exptime = {p3}

darktime = {{p1},O_TIME(7)}
factor = exptime / darktime

compute/image MODARK = {factor} * {p1} + (1-{factor}) * {p2}
write/desc MODARK o_time/r/7/1 {exptime}
set/form f5.3
write/sms "Factor = {factor}"
