! Time-stamp: <2010-10-31 18:14:05 guenter>
!
! smsinto.prg

define/par p1 ? ? "Input spectrum: "

if p1 .eq. "-h" then
   @@ sms/help/intohelp.prg
   return
endif

if {{p1},naxis} .ne. 1 then
   write/sms "{only1d}"
endif

xdx = m$indexb(p1,".") - 1
smsresult = p1
if xdx .gt. 1 smsresult = p1(1:{xdx})
if m$filtyp(p1,"?fits") .eq. 1 then
  indisk/fits {p1} {smsresult}.bdf
  write/sms "-> {smsresult}.bdf"
endif

if m$existd("{smsresult}.bdf","JD") .ne. 1 then
   set/form f18.8
   L$L$L$D = {{smsresult},o_time(4)} + 2400000.5 
   write/desc {smsresult} JD/d/1/1 {L$L$L$D}
   set/form
endif

outdisk/fits {smsresult}.bdf {smsresult}_orig.fits
write/sms "-> {smsresult}_orig.fits"
